package es.upvmaster.fullmediaplayer;

import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.AsyncTask;
import android.support.design.widget.NavigationView;
import android.support.v4.view.GravityCompat;
import android.support.v4.widget.DrawerLayout;
import android.support.v7.app.ActionBarDrawerToggle;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.StaggeredGridLayoutManager;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;

import com.google.gson.Gson;

import java.io.File;
import java.net.HttpURLConnection;
import java.net.URL;

import static es.upvmaster.fullmediaplayer.Libreria.*;

public class ListarMedios extends AppCompatActivity implements NavigationView.OnNavigationItemSelectedListener {

    private AdaptadorMedios adaptadorMedios;
    private RecyclerView recyclerView;
    private RecyclerView.LayoutManager layoutManager;
    private ListaMedios listaMedios;
    private int indiceLista;

    private MenuItem opcionPresionada = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_listar_medios);

        Intent intent = getIntent();
        indiceLista = intent.getIntExtra("IndiceLista",-1);
        if (indiceLista==-1) finish();

        this.listaMedios = InfoGlobal.getINSTANCIA().getVectorListaListas().get(indiceLista);
        InfoGlobal.getINSTANCIA().agregarMedios(this.listaMedios.getStations());
        adaptadorMedios = InfoGlobal.getINSTANCIA().getAdaptadorMedio();

        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbarMedio);
        toolbar.setTitle(this.listaMedios.getName());
        setSupportActionBar(toolbar);

        DrawerLayout drawerLayout = (DrawerLayout) findViewById(R.id.drawer_layoutMedio);
        ActionBarDrawerToggle actionBarDrawerToggle = new ActionBarDrawerToggle(this,drawerLayout,toolbar,R.string.drawer_open,R.string.drawer_close);
        drawerLayout.setDrawerListener(actionBarDrawerToggle);
        actionBarDrawerToggle.syncState();
        drawerLayout.addDrawerListener(new DrawerLayout.DrawerListener() {
            @Override
            public void onDrawerSlide(View drawerView, float slideOffset) {
            }

            @Override
            public void onDrawerOpened(View drawerView) {
            }

            @Override
            public void onDrawerClosed(View drawerView) {
                if (opcionPresionada!=null) opcionPresionada.setChecked(false);
            }

            @Override
            public void onDrawerStateChanged(int newState) {

            }
        });

        NavigationView navigationView = (NavigationView) findViewById(R.id.nav_view);
        navigationView.setNavigationItemSelectedListener(this);

        adaptadorMedios.setOnItemClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                AdaptadorMedios.ViewHolder viewHolder = (AdaptadorMedios.ViewHolder) recyclerView.getChildViewHolder(v);
                Medio medio = InfoGlobal.getINSTANCIA().getVectorMedios().get(viewHolder.getAdapterPosition());
                new ComprobarAccesoMedio(medio).execute();
            }
        });

        recyclerView = (RecyclerView) findViewById(R.id.recycler_view_lista_medios);
        recyclerView.setAdapter(adaptadorMedios);
        layoutManager = new StaggeredGridLayoutManager(2,  StaggeredGridLayoutManager.VERTICAL);
        layoutManager.setAutoMeasureEnabled(true);
        recyclerView.setLayoutManager(layoutManager);

        //if (!listaMedios.mediosCargados()) new ObtenerMedios().execute();
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (!listaMedios.mediosCargados())
            new ObtenerMedios().execute();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_listar_medio, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        Intent compartirInformacion = null;
        switch (item.getItemId()) {
            case R.id.menu_recargarLista:
                listaMedios.vaciarListaMedios();
                new ObtenerMedios().execute();
                break;
            case R.id.menu_eliminarLista:
                crearDialogoEliminar().show();
                break;
            case R.id.menu_compartirLink:
                compartirInformacion = new Intent();
                compartirInformacion.setAction(Intent.ACTION_SEND);
                compartirInformacion.putExtra(Intent.EXTRA_TEXT,this.listaMedios.getUrl());
                compartirInformacion.setType("text/plain");
                startActivity(Intent.createChooser(compartirInformacion,getResources().getString(R.string.compartir_link)));
                break;
            case R.id.menu_compartirLista:
                compartirInformacion = new Intent();
                compartirInformacion.setAction(Intent.ACTION_SEND);
                Uri fichero = Uri.parse("file://" + InfoGlobal.getINSTANCIA().getDirectorio().getAbsolutePath() + File.separator + this.listaMedios.getNameFile());
                compartirInformacion.putExtra(Intent.EXTRA_STREAM, fichero);
                compartirInformacion.setType("text/plain");
                startActivity(Intent.createChooser(compartirInformacion,getResources().getString(R.string.compartir_lista)));
                break;
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    public boolean onNavigationItemSelected(MenuItem item) {
        Intent intent;
        opcionPresionada = item;
        switch (item.getItemId()) {
            case R.id.nav_listaMedio:
                finish();
                break;
            case R.id.nav_localVideo:
                intent = new Intent(ListarMedios.this,ListarVideos.class);
                startActivity(intent);
                break;
            case R.id.nav_localAudio:
                intent = new Intent(ListarMedios.this,ListarAudios.class);
                startActivity(intent);
                break;
            case R.id.nav_archivoMedio:
                intent = new Intent(ListarMedios.this,ListarArchivos.class);
                startActivity(intent);
                break;
            case R.id.nav_urlMedio:
                intent = new Intent(ListarMedios.this,AccederMedioURL.class);
                startActivity(intent);
                break;
            case R.id.nav_preferencias:
                Intent intentPref = new Intent(this, Preferencias.class);
                startActivity(intentPref);
                break;
            case R.id.nav_salir:
                Intent intentSalir = new Intent(Intent.ACTION_MAIN);
                intentSalir.addCategory(Intent.CATEGORY_HOME);
                intentSalir.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                startActivity(intentSalir);
        }


        DrawerLayout drawerLayout = (DrawerLayout) findViewById( R.id.drawer_layoutMedio);
        drawerLayout.closeDrawer(GravityCompat.START);
        finish();
        return true;
    }

    @Override
    public void onBackPressed() {
        DrawerLayout drawerLayout = (DrawerLayout) findViewById( R.id.drawer_layoutMedio);
        if (drawerLayout.isDrawerOpen(GravityCompat.START))
        {
            drawerLayout.closeDrawer(GravityCompat.START);
        } else {
            super.onBackPressed();
        }
        finish();
    }

    private AlertDialog crearDialogoEliminar() {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);

        builder.setTitle(getResources().getString(R.string.eliminar_lista))
                .setMessage(getResources().getString(R.string.estas_seguro_eliminar_lista))
                .setPositiveButton(getResources().getString(R.string.si),
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                InfoGlobal.getINSTANCIA().eliminarListaMedios(ListarMedios.this.indiceLista,true);
                                finish();
                            }
                        })
                .setNegativeButton(getResources().getString(R.string.no),
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {

                            }
                        });

        return builder.create();
    }

    private void iniciarMedio(boolean resultado, Medio medio) {
        if (resultado) {
            iniciarReproduccion(ListarMedios.this,TipoMedio.URL,medio.getUrl());
        } else {
            mostrarMensaje(ListarMedios.this,getResources().getString(R.string.medio_no_accesible));
        }
    }

    class ObtenerMedios extends AsyncTask<Void, Void, Boolean> {
        private ProgressDialog pDialog;
        private boolean operacionCancelada = false;

        public ObtenerMedios() {
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            pDialog = new ProgressDialog(ListarMedios.this);
            pDialog.setMessage(getResources().getString(R.string.obteniendo_medios));
            pDialog.setIndeterminate(false);
            pDialog.setCancelable(true);
            pDialog.setOnCancelListener(new DialogInterface.OnCancelListener() {
                @Override
                public void onCancel(DialogInterface dialogInterface) {
                    operacionCancelada = true;
                    ObtenerMedios.this.cancel(true);
                }
            });
            pDialog.show();
        }

        @Override
        protected Boolean doInBackground(Void... arg0) {
            Medio medio;
            File fichero = new File(InfoGlobal.getINSTANCIA().getDirectorio().toString()+File.separator+ listaMedios.getNameFile());

            JSONParser sh = new JSONParser();
            String jsonStr = sh.makeServiceCall(fichero);

            if (jsonStr != null) {
                Gson gson = new Gson();
                try {
                    ListaMedios listaMediosAuxiliar = gson.fromJson(jsonStr, ListaMedios.class);
                    for (Medio medioAuxiliar : listaMediosAuxiliar.getStations()) {
                        if (!operacionCancelada) {
                            try {
                                medio = new Medio();
                                medio.setName(medioAuxiliar.getName());
                                medio.setUrl(medioAuxiliar.getUrl());
                                medio.setImage(medioAuxiliar.getImage());
                                guardarImagenURL(medio.getImage());
                                medio.setReferer(medioAuxiliar.getReferer());
                                medio.setIshost(medioAuxiliar.getIshost());
                                listaMedios.agregarMedio(medio);
                            } catch (Exception e) {
                                imprimirLog(TipoLog.ERROR, "Recuperando Medio", e.getMessage());
                            }
                        } else break;
                    }
                } catch (Exception e) {
                    imprimirLog(TipoLog.ERROR,"Interpretando JSON",e.getMessage());
                    return false;
                }
            } else {
                imprimirLog(TipoLog.DEBUG,"Service Handler", "Esta habiendo problemas para cargar el JSON");
                return false;
            }
            return true;
        }

        @Override
        protected void onPostExecute(Boolean result) {
            super.onPostExecute(result);
            if (pDialog.isShowing()){
                pDialog.dismiss();
            }

            if (result)
                adaptadorMedios.notifyDataSetChanged();
            else
                mostrarMensaje(ListarMedios.this,getResources().getString(R.string.error_recuperando_lista));
        }

        @Override
        protected void onCancelled() {
            super.onCancelled();
            finalizarActividad();
        }
    }

    private void finalizarActividad() {
        listaMedios.vaciarListaMedios();
        finish();
    }

    class ComprobarAccesoMedio extends AsyncTask<Void, Void, Boolean> {
        private Medio medio;
        private ProgressDialog pDialog;

        public ComprobarAccesoMedio(Medio medio) {
            this.medio = medio;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            pDialog = new ProgressDialog(ListarMedios.this);
            pDialog.setMessage(getResources().getString(R.string.comprobando_medio));
            pDialog.setIndeterminate(false);
            pDialog.setCancelable(true);
            pDialog.setOnCancelListener(new DialogInterface.OnCancelListener() {
                @Override
                public void onCancel(DialogInterface dialogInterface) {
                    ComprobarAccesoMedio.this.cancel(true);
                }
            });
            pDialog.show();
        }

        @Override
        protected Boolean doInBackground(Void... arg0) {
            boolean accesible = false;
            try {
                URL url = new URL(medio.getUrl());
                HttpURLConnection huc = (HttpURLConnection) url.openConnection();
                huc.setRequestMethod("HEAD");
                int codigoRespuesta=huc.getResponseCode();
                accesible = (codigoRespuesta != 404 && codigoRespuesta!= 403);
                huc.disconnect();
            } catch (Exception e) {
                imprimirLog(TipoLog.ERROR,"Comprobando medio",e.getMessage());
            }
            return accesible;
        }

        @Override
        protected void onPostExecute(Boolean result) {
            pDialog.dismiss();
            iniciarMedio(result,medio);
            super.onPostExecute(result);
        }

        @Override
        protected void onCancelled() {
            super.onCancelled();
        }
    }

}
